#ifndef _TURINGWATCHER_SQL_SQL_H
#define _TURINGWATCHER_SQL_SQL_H
#define DECLSQL(NAME, ...) extern const char * NAME __VA_ARGS__;
#ifdef __cplusplus
#include <cstdint>
#define DB_SCHEMA_VERSION                     6
#define DB_SCHEMA_VERSION_STR                "6"
#define MIGRATE_TARGET_DB_SCHEMA_VERSION      6
#define MIGRATE_TARGET_DB_SCHEMA_VERSION_STR "6"

#if MIGRATE_TARGET_DB_SCHEMA_VERSION != DB_SCHEMA_VERSION
  #if ENABLE_DEBUGOUT
    #warning "Target schema version is not current schema version"
  #else
    #error "Target schema version is not current schema version"
  #endif
#endif

constexpr uint32_t schema_version = DB_SCHEMA_VERSION;
#endif
DECLSQL(INIT_DB_SQL);
DECLSQL(UPSERT_WATCHER_SQL_RETURNING_TIMESTAMP_RANGE);
DECLSQL(REGISTER_WATCHER_SQL_RETURNING_TIMESTAMPS_AND_WATCHERID);
DECLSQL(JOBINFO_INSERT_SQL);
DECLSQL(GPU_MEASUREMENT_INSERT_SQL);
DECLSQL(GET_SCHEMA_VERSION_SQL);
DECLSQL(UPDATE_GPU_BATCH_SQL);
DECLSQL(MEASUREMENTS_INSERT_SQL);
DECLSQL(JOBSTEP_AVAILABLE_CPU_INSERT_SQL);
DECLSQL(UPDATE_SCRAPE_FREQ_LOG_SQL);
DECLSQL(APPLICATION_USAGE_INSERT_SQL);
DECLSQL(RENEW_ANALYSIS_OFFSET_SQL);
DECLSQL(RENEW_DB_SCHEMA_VERSION_SQL);

DECLSQL(PRE_ANALYZE_SQL);
DECLSQL(ANALYZE_LIST_ACTIVE_USERS);
DECLSQL(ANALYZE_CREATE_BASE_TABLES, []);
DECLSQL(ANALYZE_RESOURCE_USAGE_SQL)
DECLSQL(ANALYZE_LATEST_GPU_USAGE_SQL);
DECLSQL(ANALYZE_GPU_USAGE_HISTORY_SQL);
DECLSQL(ANALYSIS_LIST_PROBLEMATIC_LATEST_SYS_RATIO_SQL);
DECLSQL(ANALYSIS_LIST_LATEST_SYS_RATIO_SQL);
DECLSQL(ANALYZE_SYS_RATIO_HISTORY_SQL);
DECLSQL(POST_ANALYZE_SQL);
#undef DECLSQL
#endif
